#version 330
#extension GL_ARB_separate_shader_objects : enable





layout(location = 0) in vec4 _vin_Position;
layout(location = 1) in vec4 _vin_Color0;
layout(location = 2) in vec4 _vin_Color1;

struct SVertexInput
{
	vec4 Position;
	vec4 Color0;
	vec4 Color1;
	int VertexIndex;
	uint InstanceId;
};

layout(location = 0) smooth out vec4 _vout_fragColor0;

struct SVertexOutput
{
	vec4 fragColor0;
	vec4 VertexPosition;
};


layout( std140) uniform UProfilerConstant
{
	mat4 Transform;
} ProfilerConstant;


void VertexMain( in SVertexInput  vInput,  out SVertexOutput  vOutput  )
{
	vec2 curVtxUV;

	switch (vInput.VertexIndex)
	{
		default:
		case 0:
			curVtxUV = vec2(0, 0);
			break;
		case 1:
			curVtxUV = vec2(1, 0);
			break;
		case 2:
			curVtxUV = vec2(1, 1);
			break;
		case 3:
			curVtxUV = vec2(0, 1);
			break;
	}

	vec2 minPos = vInput.Position.xy;
	vec2 maxPos = vInput.Position.zw;
	vec2 vtxPosition = (vec2(1.0f, 1.0f) - curVtxUV) * minPos + curVtxUV * maxPos;
	vOutput.VertexPosition =  (( ProfilerConstant.Transform ) * (vec4(vtxPosition, 0.0f, 1.0f))) ;
	vOutput.fragColor0 = curVtxUV.y == 0.0f ? vInput.Color0 : vInput.Color1;


}


void main()
{
	SVertexInput vInput;
	SVertexOutput vOutput;

	vInput.Position = _vin_Position;
	vInput.Color0 = _vin_Color0;
	vInput.Color1 = _vin_Color1;
	vInput.VertexIndex = gl_VertexID;
	vInput.InstanceId = uint(gl_InstanceID);
	vOutput.fragColor0 = vec4(0, 0, 0, 0);
	VertexMain(vInput, vOutput);
	_vout_fragColor0 = vOutput.fragColor0;
	gl_Position = vOutput.VertexPosition;
}
